Program Final;                       {Carlos Gershenson}

Uses
	crt;

Type
        Cadena= String [30];
        Reg=record
          Producto:cadena;
          Presentacion:cadena;
          Precioc: real;
          Preciov: real;
          Existencias: real;
          Empresa:cadena;
          Direccion:string [35];
          Tel:string[15];
          CP:string [5];
          sw:boolean;
        end;
        Reg2=record
          Nombre:cadena;
          RFC:string [15];
          Direccion:string [35];
          Tel:string [15];
          CP:string [5];
          sw:boolean
        end;
        reg3=record
          Productos:array [1..10] of cadena;
          Precio:array [1..10] of real;
          Cantidad:array [1..10] of real;
          Total:real;
        end;
        Archivo=file of reg;
        archventas=file of reg2;

Var

	A:archivo;
        V:archventas;
        CH:real;
        err:boolean;
{-----------------------------------------------------------------------------}

Function Ventana1 (x1,y1,x2,y2,t,c:byte):byte;
var
	i:byte;
Begin
     textbackground(t);
     textcolor(c);
     gotoxy (x1,y1);write ('');
     gotoxy (x2,y1);write ('');
     gotoxy (x1,y2);write ('');
     gotoxy (x2,y2);write ('');
     i:=0;
     for i:=y1+1 to y2-1 do
        Begin
           gotoxy(x1,i);write ('');
           gotoxy(x2,i);write ('');
        end;
     for i:=x1+1 to x2-1 do
        Begin
           gotoxy(i,y1);write ('');
           gotoxy(i,y2);write ('');
        end;
     window (x1+1,y1+1,x2-1,y2-1);
     clrscr;

End;
{-----------------------------------------------------------------------------}

Function Ventana2 (x1,y1,x2,y2,t,c:byte):byte;
var
	i:byte;
Begin
     textbackground(t);
     textcolor(c);
     gotoxy (x1,y1);write ('');
     gotoxy (x2,y1);write ('');
     gotoxy (x1,y2);write ('');
     gotoxy (x2,y2);write ('');
     i:=0;
     for i:=y1+1 to y2-1 do
        Begin
           gotoxy(x1,i);write ('');
           gotoxy(x2,i);write ('');
        end;
     for i:=x1+1 to x2-1 do
        Begin
           gotoxy(i,y1);write ('');
           gotoxy(i,y2);write ('');
        end;
     window (x1+2,y1+2,x2,y2);
     clrscr;

End;
{-----------------------------------------------------------------------------}

Procedure Teclee;
var
  car:char;
begin
  writeln;
  writeln('Oprima una tecla para continuar');
  car:=readkey;
  clrscr;
end;

{-----------------------------------------------------------------------------}

Procedure Check(var CH:real);

var
  res:integer;

begin
  {$I-}
    readln(CH);
    res:=IOresult;
  {$I+}
  if res<>0 then
  begin
    writeln('Error');
    err:=true;
    teclee;
  end;
end;
{-----------------------------------------------------------------------------}

Procedure Abrir (var A:archivo);
var
  res:integer;
begin
  Clrscr;
  {$I-}
  Reset (A);
  res:=IOresult;
  {$I+}
  if res<>0 then
    rewrite (A);
  Close (A);
end;
{------------------------------------------------------------------------------}

Function Pos (P:cadena;var A:archivo):integer;
Var
  Re:reg;
  find:boolean;
begin
  find:=false;
  Seek(A,0);
  while not eof(A) and not find do
  begin
    Read (A,Re);
    find:=Re.Producto=P;
  end;
  if find then
    Pos:=FilePos(A) -1
  else
    Pos:=-1;
end;
{------------------------------------------------------------------------------}

Procedure Ver (R:reg);
begin
  with R do
    if R.sw then
    begin
      gotoxy(10,5);writeln ('Producto:        ',producto);
      gotoxy(10,6);writeln ('Presentacin:    ',presentacion);
      gotoxy(10,7);writeln ('Precio de compra:$',precioc:5:2);
      gotoxy(10,8);writeln ('Precio de venta: $',preciov:5:2);
      gotoxy(10,9);writeln ('Existencias:     ',existencias:1:0);
      gotoxy(10,10);writeln('Empresa:         ',empresa);
      gotoxy(10,11);writeln('Direccin:       ',direccion);
      gotoxy(10,12);writeln('Telfono:        ',tel);
      gotoxy(10,13);writeln('C.P.:            ',cp);
      if existencias<100 then
      begin
      gotoxy(20,14);writeln('Existencias bajas en ',producto);
      end;
    end;
  Teclee;
end;
{-------------------------------------------------------------------------------}

Procedure LeerReg (var R:reg);
begin
  err:=false;
  with R do
  begin
      gotoxy(10,5);write ('Producto:        '); readln(producto);
      if producto = '' then readln(producto);
      gotoxy(10,6);write ('Presentacin:    '); readln(presentacion);
      gotoxy(10,7);write ('Precio de compra:$');check(precioc);
      if err=false then begin
      gotoxy(10,8);write ('Precio de venta: $');check(preciov);
      if err=false then begin
      gotoxy(10,9);write ('Existencias:     '); check(existencias);
      if err=false then begin
      gotoxy(10,10);write('Empresa:         '); readln(empresa);
      gotoxy(10,11);write('Direccin:       '); readln(direccion);
      gotoxy(10,12);write('Telfono:        '); readln(tel);
      gotoxy(10,13);write('C.P.:            '); readln(cp);
      end;end;end;
      if err=true then
      sw:=false;
  end;
end;
{-------------------------------------------------------------------------------}

Procedure Comprimir(var A:archivo);
var
  R:reg;
  B:archivo;
begin
  Assign (B,'productb.dat');
  Rewrite(B);
  Reset (A);
  while not eof (A) do
  begin
    read(A,R);
    if R.sw then
       write(B,r);
  end;
  close (A);
  close (B);
  rewrite(A);
  reset(B);

  while not eof (B) do
  begin
    read(B,R);
    write(A,R);
  end;
  Close(A);
  Close(B);
end;

{-------------------------------------------------------------------------------}

Procedure Lista (var A:archivo);
var
  R:reg;
begin
  Reset (A);
  ventana2(4,4,75,20,2,5);
  while not eof (A) do
    begin
      clrscr;
      writeln('Folio: ',filepos(A)+1:1);
      read(A,R);
      if R.sw then
        ver (R)
      else
      begin
        gotoxy(20,7);
        writeln('Folio vaco');
        writeln;
        Teclee;
      end;
    end;
  Close (A);
end;
{-------------------------------------------------------------------------------}

Procedure Ampliar (var A:archivo);
var
  R,S:reg;
  i:integer;
  c:char;
begin
  ventana2(4,4,75,20,2,5);
  gotoxy(25,1);
  writeln ('Esta Ud. en opcin de altas');
  Reset(A);
  gotoxy(25,4);
  c:=#0;
  while (Upcase (c) <> 'S')  do
  begin
    gotoxy(20,3);
    writeln('Introduzca datos del nuevo producto');
    LeerReg (R);
    i:=Pos (R.producto,A);
    if i=-1 then
    begin
      i:=filesize(A);
      seek(A,i);
      write(A,R);
    end
    else
    begin
     seek (A,i);
     read (A,S);
     if S.sw then
     begin
       gotoxy(20,21);
       writeln('El producto ya existe');
       Teclee;
     end
     else
       write(A,R);
    end;
    gotoxy(20,25);
    repeat
      clrscr;
      writeln('Desea salir de altas? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  end;
  Close (A);
end;
{-------------------------------------------------------------------------------}

Procedure Borrar (var A:archivo);
var
  R:reg;
  P:cadena;
  i:integer;
  c,d:char;
begin
  Reset (A);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Esta Ud. en opcin de bajas');
    Reset(A);
    gotoxy(25,4);
    writeln('Escriba el nombre del producto a borrar');
    readln(P);
    repeat
      writeln('Est seguro de borrar ',(P),'? (S/N)');
      d:=readkey;
    until (Upcase (d) = 'N') or (Upcase (d) = 'S');
    clrscr;
    if Upcase (d) = 'S' then
    begin
     i:=pos(P,A);
     if i=-1 then
     begin
       gotoxy(20,11);
       writeln('No existe el producto');
     end
     else
     begin
       seek (A,i);
       read(A,R);
       if R.sw then
       begin
         Ver(R);
         R.sw:=false;
         i:= filepos(A)-1;
         seek (A,i);
         write (A,R);
       end;
       gotoxy(20,11);
       writeln('El producto fue dado de baja');
     end;
    end;
    Teclee;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de bajas? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (A);
end;
{-------------------------------------------------------------------------------}

Procedure Modificar (var A:archivo);
var
  R:reg;
  P:cadena;
  i:integer;
  c:char;
begin
  Reset (A);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Esta Ud. en opcin de modificaciones');
    gotoxy(25,4);
    writeln('Escriba el nombre del producto a modificar');
    readln(P);
    i:=pos(P,A);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('No existe el producto');
    end
    else
    begin
      seek (A,i);
      read(A,R);
      if R.sw then
      begin
        clrscr;
        ver(R);
        gotoxy(20,3);
        writeln('Introduzca nuevos datos del producto');
        LeerReg(R);
        i:=filepos (A)-1;
        seek (A,i);
        write(A,R);
        clrscr;
        gotoxy(20,21);
        writeln('Registro modificado');
      end
      else
      begin
      gotoxy(20,11);
      writeln('El producto fue dado de baja');
      end;
    end;
    Teclee;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de modificaciones? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (A);
end;
{-------------------------------------------------------------------------------}

Procedure Consultar (var A:archivo);
var
  R:reg;
  c:char;
  P:cadena;
  i:integer;
begin
  Reset (A);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Esta Ud. en opcin de consulta');
    gotoxy(25,4);
    writeln('Escriba el nombre del producto a consultar');
    readln(P);
    if p='' then readln(P);
    i:=pos(P,A);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('No existe el producto');
      teclee;
    end
    else
    begin
      seek (A,i);
      read(A,R);
      if R.sw then
      begin
        clrscr;
        ver(R);
      end
      else
      begin
        gotoxy(20,11);
        writeln('El producto fue dado de baja');
        Teclee;
      end;
    end;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de consulta? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (A);
end;
{-------------------------------------------------------------------------------}

Procedure Ventas (var A:archivo;var V:archventas);
var
  R:reg;
  R2:reg2;



{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Abrir2 (var V:archventas);
var
  res:integer;
begin
  Clrscr;
  {$I-}
  Reset (V);
  res:=IOresult;
  {$I+}
  if res<>0 then
    rewrite (V);
  Close (V);
end;
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Function Pos2 (N:cadena;var V:archventas):integer;
Var
  Re:reg2;
  find:boolean;
begin
  find:=false;
  Seek(V,0);
  while not eof(V) and not find do
  begin
    Read (V,Re);
    find:=Re.Nombre=N;
  end;
  if find then
    Pos2:=FilePos(V) -1
  else
    Pos2:=-1;
end;
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Ver2 (R2:reg2);
begin
  with R2 do
    if R.sw then
    begin
      gotoxy(10,5); writeln ('Nombre:   ',nombre);
      gotoxy(10,7); writeln ('RFC:      ',rfc);
      gotoxy(10,9); writeln ('Direccin:',direccion);
      gotoxy(10,11);writeln ('Telfono: ',tel);
      gotoxy(10,13);writeln ('C.P.:     ',CP);
    end;
  Teclee;
end;

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }


Procedure LeerReg2 (var R2:reg2);
begin
  with R2 do
  begin
      gotoxy(10,5); write ('Nombre:   '); readln(nombre);
      gotoxy(10,7); write ('RFC:      '); readln(rfc);
      gotoxy(10,9); write ('Direccin:'); readln(direccion);
      gotoxy(10,11);write ('Telfono: '); readln(tel);
      gotoxy(10,13);write ('C.P.:     '); readln(CP);
  end;
end;
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Lista2 (var V:archventas);
var
  R2:reg2;
begin
  Reset (V);
  ventana2(4,4,75,20,2,5);
  while not eof (V) do
    begin
      clrscr;
      writeln('Folio: ',filepos(V)+1:1);
      read(V,R2);
      if R2.sw then
        ver2 (R2)
      else
      begin
        gotoxy(20,7);
        writeln('Folio vaco');
        writeln;
        Teclee;
      end;
    end;
  Close (V);
end;
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Ampliar2 (var V:archventas);
var
  R2,S2:reg2;
  i:integer;
  c:char;
begin
  ventana2(4,4,75,20,2,5);
  gotoxy(25,1);
  writeln ('Registro de Clientes');
  Reset(V);
  gotoxy(25,4);
  c:=#0;
  while (Upcase (c) <> 'S')  do
  begin
    gotoxy(20,3);
    writeln('Introduzca datos del nuevo clente');
    LeerReg2 (R2);
    i:=Pos2 (R2.nombre,V);
    if i=-1 then
    begin
      i:=filesize(V);
      seek(V,i);
      write(V,R2);
    end
    else
    begin
     seek (V,i);
     read (V,S2);
     if S2.sw then
     begin
       gotoxy(20,21);
       writeln('El cliente ya existe');

     end
     else
       write(V,R2);
    end;
    gotoxy(20,25);
    repeat
      clrscr;
      writeln('Desea salir de registro de clientes? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  end;
  Close (V);
end;

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Borrar2 (var V:archventas);
var
  R2:reg2;
  N:cadena;
  i:integer;
  c,d:char;
begin
  Reset (V);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Bajas de Clientes');
    Reset(A);
    gotoxy(25,4);
    writeln('Escriba el nombre del cliente a borrar');
    readln(N);
    repeat
      writeln('Est seguro de borrar a ',(N),'? (S/N)');
      d:=readkey;
    until (Upcase (d) = 'N') or (Upcase (d) = 'S');
    clrscr;
    if Upcase (d) = 'S' then
    begin
     i:=pos2(N,V);
     if i=-1 then
     begin
       gotoxy(20,11);
       writeln('El cliente no est registrado');
     end
     else
     begin
       seek (V,i);
       read(V,R2);
       if R.sw then
       begin
         Ver2(R2);
         R2.sw:=false;
         i:= filepos(V)-1;
         seek (V,i);
         write (V,R2);
       end;
       gotoxy(20,11);
       writeln('El cliente fue dado de baja');
     end;
    end;
    Teclee;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de bajas de clientes? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (V);
end;

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Modificar2 (var V:archventas);
var
  R2:reg2;
  N:cadena;
  i:integer;
  c:char;
begin
  Reset (V);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Modificaciones de Clientes');
    gotoxy(25,4);
    writeln('Escriba el nombre del cliente a modificar');
    readln(N);
    i:=pos2(N,V);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('El cliente no est registrado');
    end
    else
    begin
      seek (V,i);
      read(V,R2);
      if R2.sw then
      begin
        clrscr;
        ver2(R2);
        gotoxy(20,3);
        writeln('Introduzca nuevos datos del cliente');
        LeerReg2(R2);
        i:=filepos (V)-1;
        seek (V,i);
        write(V,R2);
        clrscr;
        gotoxy(20,21);
        writeln('Cliente modificado');
      end
      else
      begin
      gotoxy(20,11);
      writeln('El cliente fue dado de baja');
      end;
    end;
    Teclee;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de modificaciones de clientes? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (V);
end;

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Consultar2 (var V:archventas);
var
  R2:reg2;
  c:char;
  N:cadena;
  i:integer;
begin
  Reset (V);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Consulta de clientes');
    gotoxy(25,4);
    writeln('Escriba el nombre del cliente a consultar');
    readln(N);
    i:=pos2(N,V);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('El cliente no est registrado');
      teclee;
    end
    else
    begin
      seek (V,i);
      read(V,R2);
      if R2.sw then
      begin
        clrscr;
        ver2(R2);
      end
      else
      begin
        gotoxy(20,11);
        writeln('El cliente fue dado de baja');
        Teclee;
      end;
    end;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de consulta de clientes? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (V);
end;
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Venta (var A:archivo;var V:archventas);
var
  P,N:cadena;
  R:reg;
  R2:reg2;
  R3:reg3;
  c:char;
  i,j:integer;

{-   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   - }

Procedure Nota;
var
  k,l:integer;
begin
     clrscr;
     with R2 do
       if R.sw then
       begin
        gotoxy(20,1); writeln ('Nombre:   ',nombre);
        gotoxy(20,2); writeln ('RFC:      ',rfc);
        gotoxy(20,3); writeln ('Direccin:',direccion);
        gotoxy(20,4);writeln ('Telfono: ',tel);
        gotoxy(20,5);writeln ('C.P.:     ',CP);
      end;
        gotoxy (5,7);write('Productos');
        gotoxy (30,7);write('Precio');
        gotoxy (40,7);write('Cantidad');
        gotoxy (50,7);writeln('Total');
     with R3 do
     begin
       l:=j;
       j:=0;
       For k:=1 to l do
       begin
         j:=j+1;
         gotoxy(5,(7+j));write(R3.productos[j]);
         gotoxy(30,(7+j));write('$',R3.precio[j]:5:2);
         gotoxy(40,(7+j));write(R3.cantidad[j]:1:0);
       end;
       gotoxy(50,(7+j));writeln('$',R3.total:5:2);
       teclee;
     end;
end;
{-   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   - }


begin
  Reset(A);Reset(V);
  repeat
    j:=0;
    R3.total:=0;
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Ventas');
    gotoxy(25,4);
    writeln('Escriba el nombre del cliente:');
    readln(N);
    i:=pos2(N,V);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('El cliente no est registrado.');
      gotoxy(20,12);
      writeln('Tiene que registrarlo primero');
      teclee;
    end
    else
    begin
      seek (V,i);
      read(V,R2);
      if R2.sw then
      begin
        clrscr;
        ver2(R2);
      end
      else
      begin
        gotoxy(20,11);
        writeln('El cliente fue dado de baja');
        Teclee;
      end;


   repeat
    clrscr;
    writeln('Escriba el nombre del producto a vender');
    readln(P);
    i:=pos(P,A);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('No existe el producto');
      teclee;
    end
    else
    begin
      seek (A,i);
      read(A,R);
      if R.sw then
      begin
        clrscr;
        ver(R);
        writeln('Qu cantidad desea vender?');
        j:=j+1;
        check(R3.cantidad[j]);
        R.existencias:=R.existencias - R3.cantidad[j];
        i:=filepos (A)-1;
        seek (A,i);
        write(A,R);
        If R.existencias<0 then
           begin
           clrscr;
           writeln('Las existencias no abastecen la venta');
           R.existencias:=R.existencias + R3.cantidad[j];
           i:=filepos (A)-1;
           seek (A,i);
           write(A,R);
           R3.productos[j]:=P;
           R3.precio[j]:=0;
           R3.total:=0;
           R3.cantidad[j]:=0;
           teclee;
           end
        else
        begin
        R3.productos[j]:=P;
        R3.precio[j]:=R.preciov*R3.cantidad[j];
        R3.total:=R3.total + R3.precio[j];
        end;
      end
      else
      begin
        gotoxy(20,11);
        writeln('El producto fue dado de baja');
        Teclee;
      end;
    end;
    repeat
      clrscr;
      writeln('Venta finalizada? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
   until (upcase(c)='S');
    Nota;
end;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de ventas? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  Close(A);Close(V);
end;
{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }
Procedure Comprimir2(var V:archventas);
var
  R2:reg2;
  B2:archventas;
begin
  Assign (B2,'clientb2.dat');
  Rewrite(B2);
  Reset (V);
  while not eof (V) do
  begin
    read(V,R2);
    if R2.sw then
       write(B2,r2);
  end;
  close (V);
  close (B2);
  rewrite(V);
  reset(B2);

  while not eof (B2) do
  begin
    read(B2,R2);
    write(V,R2);
  end;
  Close(V);
  Close(B2);
end;

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

Procedure Menu2(var A:archivo;var V:archventas);
var
  opc2:char;
begin
  repeat
    textmode(2);
    ventana1(1,1,80,24,1,7);
    gotoxy(26,2);  writeln ('Ventas');
    gotoxy(20,4);  writeln ('1) Venta');
    gotoxy(20,6);  writeln ('2) Registrar cliente nuevo');
    gotoxy(20,8);  writeln ('3) Borrar datos de un cliente');
    gotoxy(20,10);  writeln ('4) Modificar datos de un cliente');
    gotoxy(20,12);  writeln ('5) Consultar datos de un cliente');
    gotoxy(20,14);  writeln ('6) Lista de clientes');
    gotoxy(20,16); writeln ('7) Regresar al men principal');
    gotoxy(24,20); writeln ('Elija una opcin');
    repeat
      opc2:= readkey
    until opc2 in ['1'..'7'];
    clrscr;
    case opc2 of
      '1': Venta(A,V);
      '2': Ampliar2(V);
      '3': Borrar2(V);
      '4': Modificar2(V);
      '5': Consultar2(V);
      '6': Lista2(V);
    end;
  until opc2 = '7';
end;

{- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }

begin
     Assign (V, 'clientes.dat');
     Abrir2 (V);
     Menu2 (A,V);
     Comprimir2 (V);
end;
{-------------------------------------------------------------------------------}

Procedure Pedidos (var A:archivo);
var
  R:reg;
  P:cadena;
  cantidad,precio:real;
  c,d:char;
  i:integer;
begin
  Reset (A);
  repeat
    ventana2(4,4,75,20,2,5);
    gotoxy(25,2);
    writeln('Pedidos');
    gotoxy(25,4);
    writeln('Escriba el nombre del producto pedir');
    readln(P);
    i:=pos(P,A);
    if i=-1 then
    begin
      gotoxy(20,11);
      writeln('No existe el producto');
      teclee;
    end
    else
    begin
      seek (A,i);
      read(A,R);
      if R.sw then
      begin
        clrscr;
        writeln('Qu cantidad desea pedir?');
        check(cantidad);
        precio:=cantidad*R.precioc;
        writeln;
        repeat
          writeln('Seran $',precio:5:2,'OK? (S/N)');
          d:=readkey;
        until (Upcase (d) = 'N') or (Upcase (d) = 'S');
        if upcase(d)='S' then
        begin
          clrscr;
          gotoxy(20,2); writeln('Pedido de ',P);
          gotoxy(20,4); writeln('Empresa:         ',R.empresa);
          gotoxy(20,5); writeln('Direccin:       ',R.direccion);
          gotoxy(20,6); writeln('Telfono:        ',R.tel);
          gotoxy(20,7); writeln('C.P.:            ',R.cp);

          gotoxy(20,9);  writeln('Precio:         $',R.precioc:5:2);
          gotoxy(20,10); writeln('Cantidad:       ',cantidad:1:0);
          gotoxy(20,11); writeln('Total:          $',precio:5:2);
          teclee;
          R.existencias:=R.existencias + cantidad;
          i:=filepos (A)-1;
          seek (A,i);
          write(A,R);

        end;
      end
      else
      begin
        gotoxy(20,11);
        writeln('El producto fue dado de baja');
        Teclee;
      end;
    end;
    gotoxy(20,21);
    repeat
      clrscr;
      writeln('Desea salir de pedidos? (S/N)');
      c:=readkey;
    until (Upcase (c) = 'N') or (Upcase (c) = 'S');
  until (upcase(c)='S');
  close (A);
end;
{-------------------------------------------------------------------------------}

Procedure Ayuda;
begin
  ventana2(4,4,75,20,2,5);
  clrscr;
  gotoxy(20,5);
  writeln ('No hay ayuda');
  Teclee;
end;

{-------------------------------------------------------------------------------}

Procedure Menu (var A:archivo);
var
  opc:char;
begin
  repeat
    textmode(2);
    ventana1(1,1,80,24,1,7);
    gotoxy(23,2);  writeln ('Men Principal');
    gotoxy(20,4);  writeln ('1) Ventas');
    gotoxy(20,5);  writeln ('2) Agregar producto');
    gotoxy(20,6);  writeln ('3) Borrar producto');
    gotoxy(20,7);  writeln ('4) Modificar producto');
    gotoxy(20,8);  writeln ('5) Consultar producto');
    gotoxy(20,9);  writeln ('6) Lista de Productos');
    gotoxy(20,10); writeln ('7) Pedidos');
    gotoxy(20,11); writeln ('8) Ayuda');
    gotoxy(20,12); writeln ('9) Salida');
    gotoxy(24,20); writeln ('Elija una opcin');
    repeat
      opc:= readkey
    until opc in ['1'..'9'];
    clrscr;
    case opc of
      '1': Ventas(A,V);
      '2': Ampliar(A);
      '3': Borrar(A);
      '4': Modificar(A);
      '5': Consultar(A);
      '6': Lista(A);
      '7': Pedidos(A);
      '8': Ayuda;
    end;
  until opc = '9';
  textmode (2);
end;
{-------------------------------------------------------------------------------}



Begin
	clrscr;
        Assign (A, 'products.dat');
        Abrir (A);
        Menu (A);
        Comprimir(A);
End.
